#CONTROLCODES 1
#INCLUDE "STANDARD.DEF"
#INCLUDE "DIRSUBS.DEF"

REM PROGRAM STARTS HERE (GOTO MAIN IN STANDARD.BI)
MAIN:
  DEF FN SIGNED.BYTE(N) = N+256*(N>127)
  OB = PEEK(1):BANK PEEK(0),0
  ROM.VERSION=FN SIGNED.BYTE(PEEK($FF80))
## IF ROM.VERSION < 0 THEN PRINT "PRE-RELEASE ROM"
  GOOD.ROM = (ROM.VERSION < -45) OR (ROM.VERSION >= 45)
  IF NOT GOOD.ROM THEN PRINT "{WHT}ROM VERSION {RED}";ROM.VERSION;"{WHT} NOT SUPPORTED. PLEASE UPGRADE.":END
  IF ROM.VERSION < -47 OR ROM.VERSION >= 47 THEN FASTSERIAL = -1
  ROM.VERSION = ABS(ROM.VERSION)
  BMX.BANKLOADER=$A019
  VPOKE 1,$FA05,13
  SCREEN 0

PRINT "{ISO ON}"
IF NOT FASTSERIAL THEN POKEBVSAVE
POKE A.REG, 7
SYS SET.CHARSET
GOSUB FIXCURSOR

POKEBVSAVE:
  RESTORE BVSAVE
  POKEMSG$="SCREEN SAVE ROUTINE"
  ML.ADDR=$700
  ML.SIZE=75
  GOSUB POKEMLROUTINE

REM ALLOCATE SPACE FOR THE BMX FILE HEADER
BMX.HDR$=RPT$(32,32)
BMX.HDRSIZE=32
SAVEBANK=63

MSG$="LOADING BMX LOADER BIN":GOSUB STAT.TITLE
BLOAD "BMXA000.BIN",8,2,$A000
COLOR 1,0
CLS
  ROOTDIR$=CWD$
  IF MID$(ROOTDIR$,LEN(ROOTDIR$),1) <> "/" THEN ROOTDIR$=ROOTDIR$+"/"
  PALFILE$=ROOTDIR$+"DPAL.BIN"

START:
  GOSUB SBACKGROUND
  COLOR 1,0
  LOCATE 58,2:PRINT "{WHT}ENTER THE WORD {YEL}<EXIT>{WHT} TO END.";
  LOCATE 34,1
  PRINT " ENTER BMX FILENAME {GRN}";
  IF CALLTIME>0 THEN LOCATE 40,2:PRINT "{WHT}LAST LOADED{GRN}:{LIGHT GREEN} ";BMXFILE$
  IF CALLTIME>0 THEN LOCATE 42,2:PRINT "{WHT}BMX LOAD TIME{GRN}:{LIGHT GREEN}";CALLTIME;"{GRN} JIFFIES";
  IF CALLTIME>0 THEN LOCATE 46,2:PRINT "{WHT}SPRITE LOAD TIME{GRN}:{LIGHT GREEN}";SLOAD.TIME;"{GRN} JIFFIES";
  IF NOT CREATED THEN ELOOP
  LOCATE 44,2:PRINT "{WHT}SPRITE CREATION TIME{GRN}:{LIGHT GREEN}";CREATION.TIME;"{GRN} JIFFIES";
ELOOP:
  IT=4:IX=2:IY=36:ML=36:COLOR 5,11
  GOSUB STRINGGET
  GOSUB AREACLR
  GOSUB CLEARBOTTOM
  GOSUB CLEAR.SPRITEIMAGE
  CALLTIME=0
  S$=IS$:GOSUB UCASE
  BMXFILE$=S$
  IF BMXFILE$="" THEN FMDRUM 7,87:GOTO ELOOP
  COLOR 1,0
  PRINT:PRINT
  IF BMXFILE$="EXIT" THEN SHOWHEADER%=FALSE:GOTO ENDALL
  T$=BMXFILE$:S$=".":GOSUB INSTR
  IF ISTR=0 THEN BMXFILE$=BMXFILE$+".BMX"
  F$=BMXFILE$
  GOSUB FILEEXISTS
  IF NOT FE% THEN LOCATE 37,2:PRINT " ";"{RED}";BMXFILE$;"{WHT}  NOT FOUND!":SLEEP 90:GOTO START
  BMX$=F$
  GOSUB CLEAR.GRAPHICSBUFFER
  WASERROR=0
  STARTTIME=TI
  BMXFILE$=F$
  GOSUB LOADBMX
  ENDTIME=TI
  GOSUB SHOWHEADERINFO
SKIPBMX1:
  CALLTIME=ENDTIME-STARTTIME
  IF WASERROR THEN SLEEP 90:GOTO START

  CREATED=0
  SPR.FILENAME$=BMXFILE$+".SPRITES"
  PAL.FILENAME$=SPR.FILENAME$+".PAL"

F$=SPR.FILENAME$:GOSUB FILEEXISTS
F1%=FE%
F$=PAL.FILENAME$:GOSUB FILEEXISTS
IF F1% AND FE% THEN SLOAD.START=TI:GOTO SKIP.PROCESS


CREAT.START=TI
  MSG$= "{YEL}PROCESSING{WHT}: "+BMXFILE$:GOSUB STAT.TITLE
  GOSUB GetCWD
  RETURN.DIR$=CWD$
RETRYDIR:
  COMMAND$="CD:" + BMXFILE$+".GLYP"
  GOSUB DOS.CMD
  IF FCODE < 20 THEN PROCEEDGLYPHS
  COMMAND$="MD:" + BMXFILE$+".GLYP"
  GOSUB DOS.CMD
  GOTO RETRYDIR

PROCEEDGLYPHS:
  GLYPH.INDX = 0

X1=0:Y1=0
FOR JI = 1 TO 15
  SUFFIX$=MID$(STR$(JI),2)
  F$="GLYPH"+SUFFIX$+".BIN"
  PUTIMAGE=FALSE
  X2=X1+63:Y2=Y1+63
  MSG$= "{YEL}CREATING: {WHT}"+F$:GOSUB STAT.MSG1
  GOSUB BITBLT
  X1=X1+64
  IF X1>=320 THEN X1=O:Y1=Y1+64
NEXT JI

FOR JI = 16 TO 20
  SUFFIX$=MID$(STR$(JI),2)
  F$="GLYPH"+SUFFIX$+".BIN"
  PUTIMAGE=FALSE
  X2=X1+63:Y2=Y1+31
  MSG$= "{YEL}CREATING: {WHT}"+F$:GOSUB STAT.MSG1
  GOSUB BITBLT
  X1=X1+64
NEXT JI

X1=O:Y1=Y1+32
FOR JI = 21 TO 25
  SUFFIX$=MID$(STR$(JI),2)
  F$="GLYPH"+SUFFIX$+".BIN"
  PUTIMAGE=FALSE
  X2=X1+63:Y2=Y1+15
  MSG$= "{YEL}CREATING: {WHT}"+F$:GOSUB STAT.MSG1
  GOSUB BITBLT
  X1=X1+64
NEXT JI

CREAT.END=TI
CREATED=-1
CREATION.TIME = CREAT.END-CREAT.START

MSG$="{LIGHT GREEN}LOADING GLYPHS{WHT}":GOSUB STAT.TITLE
GLYPH.INDX = 0
VADDR = 0
VBANK = 0
SLOAD.START=TI
FOR I = 1 TO 15
  SUFFIX$=MID$(STR$(I),2)
  F$="GLYPH"+SUFFIX$+".BIN"
  MSG$= "{LIGHT GREEN}LOADING: {YEL}"+F$+"{GRN} 0:$"+HEX$(VADDR):GOSUB STAT.MSG3
  BVLOAD F$,8,VBANK,VADDR
  COMMAND$="S:"+F$
  GOSUB DOS.CMD
  VADDR = VADDR+4096
NEXT I

FOR I = 16 TO 20
  SUFFIX$=MID$(STR$(I),2)
  F$="GLYPH"+SUFFIX$+".BIN"
  MSG$= "{LIGHT GREEN}LOADING: {YEL}"+F$+"{GRN} 0:$"+HEX$(VADDR):GOSUB STAT.MSG3
  BVLOAD F$,8,VBANK,VADDR
  COMMAND$="S:"+F$
  GOSUB DOS.CMD
  VADDR = VADDR+2048
  IF VADDR>=$FFFF THEN VBANK=1:VADDR=0
NEXT I

FOR I = 21 TO 25
  SUFFIX$=MID$(STR$(I),2)
  F$="GLYPH"+SUFFIX$+".BIN"
  MSG$= "{LIGHT GREEN}LOADING: {YEL}"+F$+"{GRN} 0:$"+HEX$(VADDR):GOSUB STAT.MSG3
  BVLOAD F$,8,VBANK,VADDR
  COMMAND$="S:"+F$
  GOSUB DOS.CMD
  VADDR = VADDR+1024
NEXT I


COMMAND$="CD:"+RETURN.DIR$
MSG$=+ "{LIGHT GREEN}EXECUTING: {YEL}"+COMMAND$:GOSUB STAT.MSG3
GOSUB DOS.CMD
COMMAND$="RD:"+ BMXFILE$+".GLYP"
GOSUB DOS.CMD

F$=PAL.FILENAME$
MSG$ ="{LIGHT GREEN}SAVING: {WHT}"+PAL.FILENAME$:GOSUB STAT.MSG1
GOSUB SAVEPAL2FILE
MSG$="{RED}DONE":GOSUB STAT.MSG2


F$=BMXFILE$+".SPRITES"
MSG$="{LIGHT GREEN}SAVING FILE: {WHT}"+F$:GOSUB STAT.MSG1
GOSUB SAVESCREEN
MSG$= "{WHT}"+F$+"{YEL} SAVED!":GOSUB STAT.MSG2
MSG$="{LIGHT RED} DONE {YEL}!{WHT}":GOSUB STAT.MSG3
GOTO DO.DISPLAY

SKIP.PROCESS:
 GOSUB LOAD.SPRITEFILE
 GOTO ALL.DONE

DO.DISPLAY:
 GOSUB DISPLAY.SPRITEFILE

ALL.DONE:
 SLOAD.END = TI
 SLOAD.TIME = SLOAD.END - SLOAD.START
 VPOKE 1,$FA00,0
 VPOKE 1,$FA01,0
 COLOR 1,0
 MSG$="{WHT}":GOSUB STAT.TITLE:GOSUB STAT.MSG1:GOSUB STAT.MSG2:GOSUB STAT.MSG3
 GOTO START


LOAD.SPRITEFILE:
  BVLOAD SPR.FILENAME$,8,0,0
  BVLOAD PAL.FILENAME$,8,1,$FA00

DISPLAY.SPRITEFILE:
  VAddr = 0
  VBANK = 0

  FOR I =1 TO 15
    SPRMEM I,VBANK,VAddr
    SPRITE I,0,0,0,3,3,1
    VAddr = VAddr + 4096
  NEXT I

  FOR I =16 TO 20
    SPRMEM I,VBANK,VAddr
    SPRITE I,0,0,0,3,2,1
    VAddr = VAddr + 2048
    IF VAddr >= $FFFF THEN VBANK=1:VAddr=0
  NEXT I

  FOR I =21 TO 25
    SPRMEM I,VBANK,VAddr
    SPRITE I,0,0,0,3,1,1
    VAddr = VAddr + 1024
  NEXT I

  X1 = 304:Y1 = 4
  BCOUNT = 0
  FOR I = 1 TO 15
    MOVSPR I,X1,Y1
    SPRITE I,3
    X1=X1+64
    BCOUNT = BCOUNT + 1
    IF BCOUNT = 5 THEN BCOUNT=0:X1=304:Y1=Y1+64
  NEXT I

  FOR I = 16 TO 25
    MOVSPR I,X1,Y1
    SPRITE I,3
    X1=X1+64
    BCOUNT = BCOUNT + 1
    IF BCOUNT = 5 THEN BCOUNT=0:X1=304:Y1=Y1+32
  NEXT I
RETURN

ENDALL:
 GOSUB SETDEFPAL
 GOSUB CLEAR.SPRITEIMAGE
 CLS
 END

CLEAR.SPRITEIMAGE:
 FOR I = 1 TO 25:SPRITE I, 0:NEXT
 RETURN


SBACKGROUND:
  DLINE$=RPT$(176,44)
  COLOR 0,1
  FOR I = 1 TO 31
    LOCATE I, 37:PRINT DLINE$;
  NEXT I
 RETURN

SAVEPAL2FILE:
  FF$="@:"+F$+",S,W"
  OPEN 5,8,5,FF$
  POKE X.REG, 5
  SYS CHKOUT
  POKE VERA.LOWADDR, 0
  POKE VERA.MIDADDR, $FA
  POKE VERA.HIADDR, %00010001
  FOR I = 1 TO 4
     POKE C.REG, 1
     POKE A.REG, 128
     POKE X.REG, $23
     POKE Y.REG, $9F
     SYS MCIOUT
  NEXT I
  SYS CLRCHN
  CLOSE 5
RETURN

SAVESCREEN:
  IF F$="BACKGROUND SCREEN" THEN FF$="@:HANGBG.DAT,P,W":GOTO DOIT
  FF$="@:"+F$ + ",P,W"
DOIT:
  OPEN 2,8,2,FF$:POKE A.REG,2:POKE$9F25,0:POKE$9F20,0:POKE$9F21,0:POKE$9F22,$10:SYS$700:CLOSE 2
  RETURN

CLEARBOTTOM:
   COLOR 1,0
   X$=RPT$(32,79)
   FOR Y = 34 TO 59
    LOCATE Y,1:PRINT X$;
   NEXT Y
   LOCATE 1,1
   RETURN

SHOWHEADERINFO:
   LOCATE 40,42:PRINT RPT$(32,38);
   LOCATE 41,42:PRINT RPT$(32,38);
   LOCATE 40,42:PRINT "{WHT}BMX FILE: {GRN}";F$;"{WHT}  ";
   LOCATE 41,42:PRINT RPT$(ASC("-"),LEN(F$)+10)
   LOCATE 43,44:PRINT "       BMX HEADER ID: {GRN}";BMX.ID$;"{WHT}  "
   LOCATE 44,44:PRINT "         BMX VERSION: {GRN}";ASC(MID$(BMX.HDR$,4,1));"{WHT}  "
   LOCATE 45,44:PRINT "           BIT DEPTH: {GRN}";ASC(MID$(BMX.HDR$,5,1));"{WHT}  "
   LOCATE 46,44:PRINT "      VERA DEPTH REG: {GRN}";BMX.VERA.REG;"{WHT}  "
   LOCATE 47,44:PRINT "               WIDTH: {GRN}";BMX.WIDTH;"{WHT}  "
   LOCATE 48,44:PRINT "              HEIGHT: {GRN}";BMX.HEIGHT;"{WHT}  "
   LOCATE 49,44:PRINT "PALLETE ENTRIES USED: {GRN}";BMX.PALUSED;"{WHT}  "
   LOCATE 50,44:PRINT "     PAL INDEX START: {GRN}";BMX.FIRSTPAL;"{WHT}  "
   LOCATE 51,44:PRINT "IMG DATA FILE OFFSET: {GRN}";BMX.FILE.OFFSET;"{WHT}  "
   LOCATE 52,44:PRINT "   IMAGE COMPRESSION:  {GRN}";
   IF BMX.COMPRESS <> 0 THEN PRINT "LZSA":GOTO ENDHSHOW
   PRINT "NONE"
ENDHSHOW:
   PRINT "{WHT}  "
RETURN

LOADBMX:
     OPEN 4,8,4,BMXFILE$+",S,R"
     POKE X.REG, 4
     SYS CHKIN
     POKE A.REG, 32
## GET A POINTER TO THE BMX.HDR STRING THEN PEEK
## IT FOR THE ADDRESS TO THE STRING DATA
     A=POINTER(BMX.HDR$)+1
     POKE X.REG, PEEK(A)
     POKE Y.REG, PEEK(A+1)
     POKE C.REG, 0
     SYS MACPTR
     SYS CLRCHN
     WASERROR = 0
     DOSHOW = 0
     GOSUB PARSEHEADER
     IF BMX.ID$<>"BMX" THEN ERRMSG$= "{RED}"+F$+"{WHT} IS NOT A BMX FILE":GOTO ERR.EXIT1
     IF BMX.BITS<>8 THEN ERRMSG$= "{RED}"+STR$(BMX.BITS)+"{WHT} BITS NOT SUPPORTED":GOTO ERR.EXIT1
     IF BMX.VER<>1 THEN ERRMSG$= "{RED}"+F$+"{WHT} IS VERSION:{RED}"+STR$(BMX.VER)+"{WHT} NOT SUPPORTED!":GOTO ERR.EXIT1
     IF BMX.WIDTH > 320 THEN ERRMSG$= "{RED}"+STR$(BMX.WIDTH)+"{WHT} WIDTH NOT CURRENTLY SUPPORTED":GOTO ERR.EXIT1
     POKE R0L, FN Lo.Byte(BMX.WIDTH)
     POKE R0H, FN Hi.Byte(BMX.WIDTH)
     POKE R1L, FN Lo.Byte(BMX.HEIGHT)
     POKE R1H, FN Hi.Byte(BMX.HEIGHT)
     POKE R2L, BMX.PALUSED
     POKE R2H, BMX.FIRSTPAL
     BANK 2
     SYS BMX.BANKLOADER
     CLOSE 4
RETURN


ERR.EXIT1:
 CLOSE 4:SYS CLRCHN
ERR.EXIT:
 PRINT:PRINT " ";ERRMSG$:WASERROR=-1:RETURN

PARSEHEADER:
    BMX.ID$=LEFT$(BMX.HDR$,3)
    BMX.VER=ASC(MID$(BMX.HDR$,4,1))
    BMX.BITS = ASC(MID$(BMX.HDR$,5,1))
    BMX.VERA.REG=ASC(MID$(BMX.HDR$,6,1))
    BMX.WIDTH = ASC(MID$(BMX.HDR$,7,1)) + (ASC(MID$(BMX.HDR$,8,1))*256)
    BMX.HEIGHT = ASC(MID$(BMX.HDR$,9,1)) + (ASC(MID$(BMX.HDR$,10,1))*256)
    BMX.PALUSED = ASC(MID$(BMX.HDR$,11,1))
    BMX.FIRSTPAL = ASC(MID$(BMX.HDR$,12,1))
    BMX.FILE.OFFSET = ASC(MID$(BMX.HDR$,13,1))+(ASC(MID$(BMX.HDR$,14,1))*256)
    BMX.COMPRESS= ASC(MID$(BMX.HDR$,15,1))
   RETURN



## BITBLIT IS CALLED WITH PUTIMAGE = 0 (FALSE) TO GET THE IMAGE
## IMAGE IS BUFFERED TO FILE PASSED IN F$
## SCREEN RECTANGLE TO CAPTURE IS PASSED IN X1, Y1, X2, Y2
##
##
## BITBLIT IS CALLED WITH PUTIMAGE = -1 (TRUE) TO PUT THE IMAGE
## ON THE SCREEN F$ WILL HOLD FILE NAME.
## PUT STARTING AT X1, Y1
##
## BLITWIDTH AND BLITLINES NEED TO BE SET TO THE WIDTH AND HEIGHT
## OF THE IMAGE RESPECTIVELY, NO SUCH INFO IS IN THE FILE.
##
## IF IMMEDIATELY FOLLOWING A BITBLIT GETIMAGE CALL THEN
## BLITWIDTH AND BLITLINES WILL ALREADY BE SET.
## IN THAT INSTANCE ONLY X1, Y1 NEED TO BE CHANGED
##
## X1 AND Y1 CAN BE LEFT UNCHANGED IF THE USE IS SAVING A
## SECTION OF SCREEN TO RESTORE AFTER SOMETHING ELSE IS DRAWN
##
##
## FOR THAT CASE CALL BITBLIT WITH PUTIMAGE = FALSE
## DO YOUR SCREEN STUFF
## SET PUTIMAGE TO TRUE,  CALL BITBLIT AGAIN TO RESTORE ALREADY


BITBLT:
    ADDON$=",P,W"
    PREFIX$="@:"
    IF PUTIMAGE THEN PREFIX$="":ADDON$=",S,R"
    FF$=PREFIX$ + F$ + ADDON$
    IF PUTIMAGE THEN SET.IO=CHKIN:DO.FILEIO=MACPTR:GOTO DOSCREENBLIT
    SET.IO = CHKOUT
    DO.FILEIO = MCIOUT
    IF X2>XLIMIT THEN X2=XLIMIT
    IF Y2>YLIMIT THEN Y2=YLIMIT
    BLITWIDTH = (X2-X1) + 1
    BLITLINES = (Y2-Y1) + 1
DOSCREENBLIT:
    OPEN 2,8,2,FF$
    POKE X.REG, 2
    SYS SET.IO
   IF X1 > 255 THEN BYTESPLIT
   POKE R0L, X1
   POKE R0H, 0
   GOTO POKEY
BYTESPLIT:
  POKE R0L, X1 AND $00FF
  POKE R0H, INT(X1/256)
POKEY:
   POKE R1L, Y1
   POKE R1H, 0
   SYS FB.CURSOR.POSITION
   FOR Y= 1 TO BLITLINES
       I=0
   INLOOP:
       BYTES=BLITWIDTH-I
       IF BYTES>$FF THEN BYTES=$FF
       POKE A.REG, BYTES
       POKE X.REG, $23
       POKE Y.REG, $9F
       POKE C.REG, $01
       SYS DO.FILEIO
       I=I+PEEK(X.REG)
       IF I<BLITWIDTH THEN INLOOP
       SYS FB.CURSOR.NEXTLINE
    NEXT Y
    CLOSE 2
    SYS CLRCHN
    RETURN

POKEMLROUTINE:
  PRINT "{CR}{YEL}POKING{GRN}: {WHT}";POKEMSG$;"{GRN}";
  FOR I = 0 TO (ML.SIZE-1)
      READ C
      POKE ML.ADDR+I, C
      PRINT ".";
  NEXT I
  PRINT "{CR}{WHT}"
  RETURN

SETDEFPAL:
      F$=PALFILE$:GOSUB FILEEXISTS
      IF FE% THEN BVLOAD F$,8,1,$FA00:RETURN
      POKE $9F20, 0
      POKE $9F21, $FA
      POKE $9F22, %00010001
      RESTORE PALDATA
REM LOOP THROUGH THE PALLETTE ADDRESS SPACE
REM AND POKE THE VERA DEFAULT PALLETTE
      FOR PE = 1 TO 256
          READ R:READ GB
          POKE $9F23,GB
          POKE $9F23,R
      NEXT PE
      RETURN

STAT.TITLE:
  LOCATE 3, 2
  COLOR 1,0
  PRINT RPT$(32,35);
  LOCATE 3, 2
  PRINT MSG$;
  RETURN 

STAT.MSG1:
  LOCATE 5,2
  COLOR 1,0
  PRINT RPT$(32,35);
  LOCATE 5,2
  PRINT MSG$
  RETURN

STAT.MSG2:
  LOCATE 7,2
  COLOR 1,0
  PRINT RPT$(32,35);
  LOCATE 7, 2
  PRINT MSG$
  RETURN

STAT.MSG3:
  LOCATE 9,2
  COLOR 1,0
  PRINT RPT$(32,35);
  LOCATE 9, 2
  PRINT MSG$
  RETURN

## 75 BYTES
BVSAVE:
   DATA $AA,$20,$C9,$FF,$9C,$4B,$07,$A9,$2C,$8D,$4C,$07,$A9,$01,$8D,$4D,$07,$A2
   DATA $23,$A0,$9F,$AD,$4B,$07,$38,$20,$B1,$FE,$B0,$29,$8E,$4E,$07,$AD,$4B,$07
   DATA $38,$ED,$4E,$07,$8D,$4B,$07,$AD,$4C,$07,$8C,$4E,$07,$ED,$4E,$07,$8D,$4C
   DATA $07,$AD,$4D,$07,$E9,0,$8D,$4D,$07,$0D,$4B,$07,$0D,$4C,$07,$D0,$CA,$20
   DATA $CC,$FF,$60

REM DEFAULT VERA PALLETTE AS DATA. FROM 0 TO 255 (2 BYTES EACH ENTRY)RGB
PALDATA:
      DATA $00,$00,$0F,$FF,$08,$00,$0A,$FE,$0C,$4C,$00,$C5,$00,$0A,$0E,$E7,$0D
      DATA $85,$06,$40,$0F,$77,$03,$33,$07,$77,$0A,$F6,$00,$8F,$0B,$BB,$00,$00
      DATA $01,$11,$02,$22,$03,$33,$04,$44,$05,$55,$06,$66,$07,$77,$08,$88,$09
      DATA $99,$0A,$AA,$0B,$BB,$0C,$CC,$0D,$DD,$0E,$EE,$0F,$FF,$02,$11,$04,$33
      DATA $06,$44,$08,$66,$0A,$88,$0C,$99,$0F,$BB,$02,$11,$04,$22,$06,$33,$08
      DATA $44,$0A,$55,$0C,$66,$0F,$77,$02,$00,$04,$11,$06,$11,$08,$22,$0A,$22
      DATA $0C,$33,$0F,$33,$02,$00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F
      DATA $00,$02,$21,$04,$43,$06,$64,$08,$86,$0A,$A8,$0C,$C9,$0F,$EB,$02,$11
      DATA $04,$32,$06,$53,$08,$74,$0A,$95,$0C,$B6,$0F,$D7,$02,$10,$04,$31,$06
      DATA $51,$08,$62,$0A,$82,$0C,$A3,$0F,$C3,$02,$10,$04,$30,$06,$40,$08,$60
      DATA $0A,$80,$0C,$90,$0F,$B0,$01,$21,$03,$43,$05,$64,$07,$86,$09,$A8,$0B
      DATA $C9,$0D,$FB,$01,$21,$03,$42,$04,$63,$06,$84,$08,$A5,$09,$C6,$0B,$F7
      DATA $01,$20,$02,$41,$04,$61,$05,$82,$06,$A2,$08,$C3,$09,$F3,$01,$20,$02
      DATA $40,$03,$60,$04,$80,$05,$A0,$06,$C0,$07,$F0,$01,$21,$03,$43,$04,$65
      DATA $06,$86,$08,$A8,$09,$CA,$0B,$FC,$01,$21,$02,$42,$03,$64,$04,$85,$05
      DATA $A6,$06,$C8,$07,$F9,$00,$20,$01,$41,$01,$62,$02,$83,$02,$A4,$03,$C5
      DATA $03,$F6,$00,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$01
      DATA $22,$03,$44,$04,$66,$06,$88,$08,$AA,$09,$CC,$0B,$FF,$01,$22,$02,$44
      DATA $03,$66,$04,$88,$05,$AA,$06,$CC,$07,$FF,$00,$22,$01,$44,$01,$66,$02
      DATA $88,$02,$AA,$03,$CC,$03,$FF,$00,$22,$00,$44,$00,$66,$00,$88,$00,$AA
      DATA $00,$CC,$00,$FF,$01,$12,$03,$34,$04,$56,$06,$68,$08,$8A,$09,$AC,$0B
      DATA $CF,$01,$12,$02,$24,$03,$46,$04,$58,$05,$6A,$06,$8C,$07,$9F,$00,$02
      DATA $01,$14,$01,$26,$02,$38,$02,$4A,$03,$5C,$03,$6F,$00,$02,$00,$14,$00
      DATA $16,$00,$28,$00,$2A,$00,$3C,$00,$3F,$01,$12,$03,$34,$05,$46,$07,$68
      DATA $09,$8A,$0B,$9C,$0D,$BF,$01,$12,$03,$24,$04,$36,$06,$48,$08,$5A,$09
      DATA $6C,$0B,$7F,$01,$02,$02,$14,$04,$16,$05,$28,$06,$2A,$08,$3C,$09,$3F
      DATA $01,$02,$02,$04,$03,$06,$04,$08,$05,$0A,$06,$0C,$07,$0F,$02,$12,$04
      DATA $34,$06,$46,$08,$68,$0A,$8A,$0C,$9C,$0F,$BE,$02,$11,$04,$23,$06,$35
      DATA $08,$47,$0A,$59,$0C,$6B,$0F,$7D,$02,$01,$04,$13,$06,$15,$08,$26,$0A
      DATA $28,$0C,$3A,$0F,$3C,$02,$01,$04,$03,$06,$04,$08,$06,$0A,$08,$0C,$09
      DATA $0F,$0B


#INCLUDE "STANDARD.BI"
#INCLUDE "DIRSUBS.BI"
